local addonName, vars = ...
local L = vars.L
BOPCraftConfirm = vars
local addon = BOPCraftConfirm
local settings

local debugEnabled = false -- for addon debugging

local defaults = {
}

local function chatMsg(msg) 
     DEFAULT_CHAT_FRAME:AddMessage(addonName..": "..msg)
end
local function debug(msg) 
  if debugEnabled then
     chatMsg(msg)
  end
end

addon.scantt = CreateFrame("GameTooltip", addonName.."_Tooltip", UIParent, "GameTooltipTemplate")

local blizzard_DoTradeSkill
local save_idx, save_cnt, save_link
local function bopcc_DoTradeSkill(idx,cnt)   
   local link = GetTradeSkillItemLink(idx)
   debug(link,idx,cnt)   

   if not link then
     blizzard_DoTradeSkill(idx,cnt)
     return
   end

   local bop
   addon.scantt:ClearLines()
   addon.scantt:SetOwner(UIParent, "ANCHOR_NONE");
   addon.scantt:SetHyperlink(link)
   for i=1,addon.scantt:NumLines() do
     local line = getglobal(addon.scantt:GetName() .. "TextLeft"..i)
     local text = line and line:GetText()
     if text and text:find(ITEM_BIND_ON_PICKUP) then
       bop = ITEM_BIND_ON_PICKUP
       break
     elseif text and text:find(ITEM_BIND_TO_ACCOUNT) then
       bop = ITEM_BIND_TO_ACCOUNT
       break
     elseif text and text:find(ITEM_BIND_TO_BNETACCOUNT) then
       bop = ITEM_BIND_TO_BNETACCOUNT
       break
     elseif text and (text:find(ITEM_BIND_ON_USE) or text:find(ITEM_BIND_ON_EQUIP)) then
       break
     end
   end

   if bop then
     save_idx = idx
     save_cnt = cnt
     save_link = link
     StaticPopupDialogs["BOPCRAFTCONFIRM_CONFIRM"].text =  
        save_link.."\n"..bop.."\n"..L["Crafting this item will bind it to you."]
     StaticPopup_Show("BOPCRAFTCONFIRM_CONFIRM")
   else
     blizzard_DoTradeSkill(idx,cnt)
   end
end

blizzard_DoTradeSkill = _G["DoTradeSkill"]
_G["DoTradeSkill"] = bopcc_DoTradeSkill

local function CraftConfirmed()
   local link = GetTradeSkillItemLink(save_idx)
   if link == save_link then
     debug("CraftConfirmed: "..link)
     blizzard_DoTradeSkill(save_idx,save_cnt)
   else -- trade window changed
     debug("CraftConfirmed: Aborting "..link)
   end
end

StaticPopupDialogs["BOPCRAFTCONFIRM_CONFIRM"] = {
  preferredIndex = 3, -- prevent taint
  text = "dummy",
  button1 = OKAY,
  button2 = CANCEL,
  OnAccept = CraftConfirmed,
  timeout = 0,
  hideOnEscape = true,
  -- enterClicksFirstButton = true, -- this doesnt work (needs a hardware mouse click event?)
  showAlert = true,
}

